#include <stdio.h>
#include <unistd.h>
#include <signal.h>

#define NUMS 48 
#define LEVELS 10

int r[LEVELS];
int max;

int f[LEVELS][NUMS];

int rec_deep[NUMS];
int rec_length[NUMS];
int rec[NUMS][LEVELS];

void init()
{	
	int i;
	for(i=0; i<NUMS; i++)
	{
		rec_deep[i]=LEVELS;
		rec_length[i]=i*(i+1)/2;
	}
}

void print_stat(int signal)
{
	int k;

	fprintf(stderr, "-----------\n");
	for(k=1; k<NUMS; k++)
	{
		int i;

		fprintf(stderr, "RZ(%2u)  %2u  [0", k, rec_deep[k]);

		for(i=1; i<rec_deep[k]; i++)
		{
			fprintf(stderr, ",%u",rec[k][i]);	
		}

		fprintf(stderr, "] \n");
	}
	fprintf(stderr, "-----------\n");
	fflush(stderr);
	alarm(5);
}

void print_roz(int max, int z)
{
	int t;
	char sep;

	printf("roz(%2u) -> (%2u) ", z, max);
	sep = '[';

	for(t=0; t<max; t++)
	{
		printf("%c%u", sep, r[t]);
		sep=',';
	}
	printf("]");
}

void roz_check_f(int max)
{
	int i;
	for(i=1; i<=NUMS; i++)
	{
		if( ! f[max-1][i] ) return;
		
		if(
			(max < rec_deep[i]) ||
			(max == rec_deep[i] && r[max-1]<rec_length[i])
		) {
			int j;
			print_roz(max, i);
			printf("\n");
			fflush(stdout);
			rec_deep[i]=max;
			rec_length[i]=r[max-1];

			for(j=0; j<max; j++)
				rec[i][j]=r[j];		
		}
	}
}

void update_f(int deep, int q)
{
	int i;
	
	for(i=1; i<=NUMS; i++)
		f[deep][i]=f[deep-1][i];
	
	for(i=0; i<deep; i++)
		if(q-r[i]<NUMS)
			f[deep][q-r[i]]++;
}

void roz_make(int from, int deep, int max)
{
	int q;

	roz_check_f(deep);
	if(deep==LEVELS) return;

	for(q=from; q<=r[deep-1]+NUMS; q++)
	{
		update_f(deep, q);
		r[deep]=q;
		roz_make(q+1, deep+1, max);
	}
}

void roz()
{
	int minTag=2;

	for(;minTag<LEVELS ; minTag++)
	{
		r[0]=0;

		fprintf(stderr, "roz() with maximum %u tag                    \n",
				minTag);

		roz_make(1,1,minTag);
	}
}


int main()
{
	signal(SIGALRM, *print_stat);	
	init();
	
	alarm(2);
	roz();
}

